//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DGlutCamera
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DGlutCamera.h,v 1.14 2001/07/15 14:29:13 probert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DGlutCamera_h_INCLUDE
#define __G3DGlutCamera_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/GeometryKit.h>

#import <RenderKit/G3DCamera.h>
#import <RenderKit/G3DTypes.h>

#ifdef GNUSTEP
#include <GL/gl.h>
#include <GL/glut.h>
#else
#include <OpenGL/gl.h>
#include <GLUT/glut.h>
#endif

@interface G3DGlutCamera : G3DCamera 
{
  @private

  BOOL _knowsRE;
  BOOL _knowsRB;
  BOOL _knowsRM;
  BOOL _knowsRPM;
  BOOL _knowsRSE;
  BOOL _knowsII;
}

//-----------------------------------------------------------------------------
// Init methods
//-----------------------------------------------------------------------------

- (id)initWithSize:(NSSize)aSize;
- (id)initWithSize:(NSSize)aSize fullscreen:(BOOL)yn;

//-----------------------------------------------------------------------------
// Rendering and glut methods
//-----------------------------------------------------------------------------

- (void)renderScene;
// Starts the glutMainLoop()

//-----------------------------------------------------------------------------
// glut callbacks
//-----------------------------------------------------------------------------

- (void)reshapeWidth:(int)w height:(int)h;

- (void)keyboardEvent:(unsigned char)c x:(int)x y:(int)y;
- (void)mouseButtonPressed:(int)button state:(int)state x:(int)x y:(int)y;
- (void)motionAtX:(int)x y:(int)y;
- (void)passiveMotionAtX:(int)x y:(int)y;
- (void)specialKeyboardEvent:(int)key x:(int)x y:(int)y;
- (void)idle;

@end

@interface NSObject (G3DGlutCameraDelegate)

- (void)glutCamera:(id)sender didReceiveEvent:(unsigned char)c x:(int)x y:(int)y;
- (void)glutCamera:(id)sender didReceiveButton:(int)button state:(int)state x:(int)x y:(int)y;
- (void)glutCamera:(id)sender didReceiveMotionAtX:(int)x y:(int)y;
- (void)glutCamera:(id)sender didReceivePassiveMotionAtX:(int)x y:(int)y;
- (void)glutCamera:(id)sender didReceiveSpecialEvent:(int)k x:(int)x y:(int)y;
- (void)glutCameraIsIdle:(id)sender;

@end

extern NSString *G3DGlutCameraException;

#endif
